# Approaching Terminus - countdown.py
#
# Copyright (C) 2014 Guillaume Tucker <guillaume@mangoz.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Lesser General Public License as published by the Free
# Software Foundation, either version 3 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
# details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import sys
import festival
import splat.data
import splat.filters

def main(argv):
    f_out = argv[1]
    msg = splat.data.Fragment()
    for x in range(10):
        count = festival.tts("{}".format(10 - x), 'us1_mbrola')
        msg.mix(count, offset=x)
    delays = splat.filters.reverb_delays(rate=30, dec=2.0, length=2.0)
    splat.filters.reverb(msg, delays)
    msg.normalize()
    msg.save(f_out)
    return True

if __name__ == '__main__':
    sys.exit(0 if main(sys.argv) is True else 1)
