# Approaching Terminus - festival.py
#
# Copyright (C) 2014 Guillaume Tucker <guillaume@mangoz.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Lesser General Public License as published by the Free
# Software Foundation, either version 3 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
# details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import subprocess
try:
    from cStringIO import StringIO
except ImportError:
    from StringIO import StringIO
import splat.data

def resample(frag):
    out = splat.data.Fragment(duration=frag.duration)
    i = 0
    for s in frag:
        for n in range(3):
            out[i] = (s[0], s[0])
            i += 1
    return out

def tts(text, voice):
    p = subprocess.Popen("text2wave -eval \"(voice_{})\"".format(voice),
                         shell=True, stdin=subprocess.PIPE,
                         stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    out, err = p.communicate(text)
    data = StringIO(out)
    frag = splat.data.Fragment.open(data, fmt='wav')
    if True: # hack to convert mono-16kHz to stereo-48kHz
        frag = resample(frag)
    return frag
