# Approaching Terminus - jump.py
#
# Copyright (C) 2014 Guillaume Tucker <guillaume@mangoz.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Lesser General Public License as published by the Free
# Software Foundation, either version 3 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
# details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import sys
import splat
import splat.gen
import splat.data
import splat.filters

audio_input = "input/jump.flac"
duration = 0.1

def main(argv):
    f_out = argv[1]
    frag = splat.data.Fragment.open(audio_input)
    gen = splat.gen.SquareGenerator(frag=frag)
    gen.run(0.0, frag.duration, 80.0, levels=-25.0)
    gen.run(0.0, frag.duration, 800.0, levels=-30.0)
    gen.run(0.0, frag.duration, 8000.0, levels=-20.0)
    delays = splat.filters.reverb_delays(rate=1000, dec=0.5, length=0.1)
    splat.filters.reverb(frag, delays)
    frag.normalize()
    frag.save(f_out, end=frag.s2n(duration))
    return True

if __name__ == '__main__':
    sys.exit(0 if main(sys.argv) is True else 1)
