# Approaching Terminus - landing.py
#
# Copyright (C) 2014 Guillaume Tucker <guillaume@mangoz.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Lesser General Public License as published by the Free
# Software Foundation, either version 3 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
# details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import sys
import splat.data
import splat.filters
import splat.interpol

audio_input = "input/landing.flac"
duration = 100.0
levels = [(0.0, -60.0), (3.0, 0.0, 0.0),
          (duration - 15.0, 0.0), (duration, -100.0)]

def main(argv):
    f_out = argv[1]
    frag_in = splat.data.Fragment.open(audio_input)
    splat.filters.reverse(frag_in)
    start = 80.0
    frag = splat.data.Fragment()
    frag.mix(frag_in, start=start, duration=duration)
    frag.amp(splat.interpol.spline(levels).value)
    frag.normalize()
    frag.save(f_out)
    return True

if __name__ == '__main__':
    sys.exit(0 if main(sys.argv) is True else 1)
