# Approaching Terminus - tools.py
#
# Copyright (C) 2014 Guillaume Tucker <guillaume@mangoz.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Lesser General Public License as published by the Free
# Software Foundation, either version 3 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
# details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import splat.data
import splat.gen

def rotamp(frag, period, amp, ratio):
    rot_freq = 1 / period
    rot_gen = splat.gen.SineGenerator()
    rot_gen.frag = lvl_l = splat.data.Fragment(channels=1)
    rot_gen.run(0.0, frag.duration, rot_freq, levels=amp)
    rot_gen.frag = lvl_r = splat.data.Fragment(channels=1)
    rot_gen.run(0.0, frag.duration, rot_freq, phase=(1 / (ratio * rot_freq)),
                levels=amp)
    frag.amp((lvl_l, lvl_r))
